// ----
// ---- file   : curve_dev.cpp
// ---- author : bsp
// ---- legal  : Distributed under terms of the MIT license (https://opensource.org/licenses/MIT)
// ----
// ----          Permission is hereby granted, free of charge, to any person obtaining a copy of this software and 
// ----          associated documentation files (the "Software"), to deal in the Software without restriction, including 
// ----          without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell 
// ----          copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to 
// ----          the following conditions:
// ----  
// ----          The above copyright notice and this permission notice shall be included in all copies or substantial 
// ----          portions of the Software.
// ----
// ----          THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT
// ----          NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
// ----          IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
// ----          WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE 
// ----          SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
// ----
// ---- info   : auto-generated by "Cycle"
// ----           $ g++ -Wall -Wno-unused-function -Wno-unused-variable -I../../tksampler -c curve_dev.cpp -o curve_dev.o
// ---- created: 27Aug2023 11:13:13
// ----
// ----
// ----

#include <plugin.h>

#include <stdlib.h>
#include <math.h>
#include <string.h>




#define NUM_PARAMS               0
static const char *loc_param_names[NUM_PARAMS] = {

};
static float loc_param_resets[NUM_PARAMS] = {

};

#define NUM_MODS                 0
static const char *loc_mod_names[NUM_MODS] = {

};

typedef struct curve_dev_info_s {
   st_plugin_info_t base;
} curve_dev_info_t;

typedef struct curve_dev_shared_s {
   st_plugin_shared_t base;
   float params[NUM_PARAMS];

} curve_dev_shared_t;

typedef struct curve_dev_voice_s {
   st_plugin_voice_t base;
   float             sample_rate;
   float             note_speed_fixed;
   float             note_speed_cur;
   float             note_speed_inc;
   float             note_cur;
   float             note_inc;
   float             mods[NUM_MODS];

   float tmp1_sin_phase;
   float tmp2_sin_speed;
   float tmp3_freq;
   float tmp4_sin_tmp;
   float var_x;

} curve_dev_voice_t;

#define loop(X)  for(unsigned int i = 0u; i < (X); i++)
#define clamp(a,b,c) (((a)<(b))?(b):(((a)>(c))?(c):(a)))

static inline float mathLerpf(float _a, float _b, float _t) { return _a + (_b - _a) * _t; }
static inline float mathClampf(float a, float b, float c) { return (((a)<(b))?(b):(((a)>(c))?(c):(a))); }
static inline float mathMinf(float a, float b) { return (a<b)?a:b; }
static inline float mathMaxf(float a, float b) { return (a>b)?a:b; }
static inline float mathAbsMaxf(float _x, float _y) { return ( ( (_x<0.0f)?-_x:_x)>((_y<0.0f)?-_y:_y)?_x:_y ); }
static inline float mathAbsMinf(float _x, float _y) { return ( ((_x<0.0f)?-_x:_x)<((_y<0.0f)?-_y:_y)?_x:_y ); }

static inline float winLinear(const float *_s, float _index) {
   int idx = (int)_index;
   float r = _index - (float)idx;
   return mathLerpf(_s[idx], _s[idx+1], r);
}

static float ffrac_s(float _f) { int i; if(_f >= 0.0f) { i = (int)_f; return _f - (float)i; } else { i = (int)-_f; return 1.0f - (-_f - (float)i); } }
static short curve_0[2048] = {
32767, 30635, 29365, 28385, 27566, 26853, 26216, 25639, 25108, 24615, 24155, 23723, 23316, 22929, 22561, 22210, 21874, 21552, 21243, 20945, 20658, 20380, 20113, 19853, 19602, 19358, 19121, 18891, 18668, 18450, 18238, 18031, 
17829, 17633, 17440, 17253, 17069, 16890, 16714, 16543, 16375, 16210, 16049, 15891, 15736, 15584, 15435, 15289, 15146, 15005, 14866, 14731, 14597, 14466, 14337, 14210, 14086, 13963, 13843, 13724, 13608, 13493, 13380, 13269, 
13159, 13051, 12945, 12841, 12738, 12637, 12537, 12438, 12341, 12245, 12151, 12058, 11966, 11876, 11786, 11699, 11612, 11526, 11442, 11359, 11277, 11196, 11115, 11037, 10959, 10882, 10806, 10730, 10657, 10584, 10511, 10441, 
10370, 10301, 10232, 10164, 10097, 10031, 9965, 9902, 9838, 9774, 9713, 9651, 9590, 9531, 9471, 9412, 9355, 9297, 9241, 9185, 9129, 9075, 9021, 8967, 8915, 8863, 8811, 8760, 8710, 8660, 8611, 8562, 
8513, 8466, 8419, 8372, 8326, 8281, 8235, 8191, 8147, 8103, 8060, 8018, 7975, 7934, 7893, 7852, 7811, 7772, 7732, 7693, 7654, 7616, 7578, 7541, 7504, 7467, 7431, 7395, 7359, 7325, 7291, 7256, 
7222, 7188, 7154, 7121, 7089, 7057, 7025, 6994, 6962, 6930, 6900, 6870, 6840, 6811, 6781, 6751, 6722, 6694, 6666, 6638, 6611, 6583, 6555, 6528, 6502, 6476, 6451, 6425, 6399, 6373, 6348, 6324, 
6300, 6275, 6251, 6227, 6203, 6180, 6157, 6135, 6112, 6090, 6067, 6044, 6023, 6002, 5981, 5960, 5939, 5918, 5896, 5877, 5857, 5837, 5817, 5798, 5778, 5758, 5740, 5721, 5703, 5684, 5666, 5648, 
5629, 5612, 5594, 5577, 5560, 5543, 5525, 5508, 5491, 5475, 5459, 5443, 5427, 5411, 5395, 5379, 5364, 5349, 5333, 5318, 5303, 5288, 5273, 5259, 5245, 5230, 5216, 5202, 5188, 5174, 5160, 5147, 
5133, 5120, 5106, 5093, 5080, 5067, 5054, 5041, 5029, 5016, 5004, 4991, 4978, 4966, 4954, 4943, 4931, 4919, 4907, 4895, 4883, 4872, 4861, 4849, 4838, 4827, 4815, 4804, 4793, 4782, 4771, 4761, 
4750, 4739, 4728, 4718, 4707, 4697, 4687, 4676, 4666, 4656, 4645, 4635, 4625, 4615, 4605, 4595, 4586, 4576, 4566, 4556, 4546, 4537, 4527, 4517, 4508, 4498, 4489, 4479, 4470, 4460, 4451, 4442, 
4432, 4423, 4414, 4405, 4395, 4386, 4377, 4368, 4359, 4350, 4341, 4332, 4323, 4314, 4305, 4297, 4288, 4279, 4270, 4262, 4253, 4245, 4236, 4228, 4219, 4210, 4202, 4194, 4185, 4177, 4169, 4161, 
4152, 4144, 4136, 4127, 4119, 4111, 4103, 4095, 4087, 4079, 4071, 4063, 4055, 4048, 4040, 4032, 4024, 4017, 4009, 4001, 3993, 3986, 3978, 3970, 3963, 3955, 3948, 3940, 3933, 3925, 3918, 3910, 
3903, 3896, 3888, 3881, 3874, 3867, 3859, 3852, 3845, 3838, 3830, 3823, 3816, 3809, 3802, 3795, 3788, 3781, 3774, 3767, 3760, 3753, 3746, 3739, 3732, 3725, 3719, 3712, 3705, 3698, 3692, 3685, 
3678, 3671, 3664, 3658, 3651, 3645, 3638, 3632, 3625, 3618, 3612, 3605, 3599, 3592, 3586, 3579, 3573, 3567, 3560, 3554, 3548, 3541, 3535, 3528, 3522, 3516, 3509, 3503, 3497, 3491, 3485, 3479, 
3472, 3466, 3460, 3454, 3448, 3442, 3436, 3429, 3423, 3417, 3411, 3405, 3399, 3394, 3388, 3382, 3376, 3370, 3364, 3358, 3352, 3346, 3340, 3334, 3329, 3323, 3317, 3311, 3306, 3300, 3294, 3288, 
3283, 3277, 3271, 3265, 3260, 3254, 3248, 3243, 3237, 3232, 3226, 3220, 3215, 3209, 3204, 3198, 3193, 3187, 3182, 3176, 3171, 3165, 3160, 3155, 3149, 3144, 3138, 3133, 3128, 3122, 3117, 3112, 
3106, 3101, 3096, 3090, 3085, 3080, 3075, 3070, 3064, 3059, 3054, 3049, 3043, 3038, 3033, 3028, 3023, 3018, 3013, 3008, 3002, 2997, 2992, 2987, 2982, 2977, 2972, 2967, 2962, 2957, 2952, 2947, 
2942, 2937, 2932, 2927, 2922, 2917, 2913, 2908, 2903, 2898, 2893, 2888, 2883, 2878, 2874, 2869, 2864, 2859, 2854, 2850, 2845, 2840, 2835, 2831, 2826, 2821, 2816, 2812, 2807, 2802, 2798, 2793, 
2788, 2784, 2779, 2774, 2770, 2765, 2760, 2756, 2751, 2747, 2742, 2737, 2733, 2728, 2724, 2719, 2715, 2710, 2706, 2701, 2697, 2692, 2688, 2683, 2679, 2674, 2670, 2665, 2661, 2657, 2652, 2648, 
2643, 2639, 2635, 2630, 2626, 2622, 2617, 2613, 2609, 2604, 2600, 2596, 2591, 2587, 2583, 2578, 2574, 2570, 2566, 2561, 2557, 2553, 2549, 2544, 2540, 2536, 2532, 2528, 2523, 2519, 2515, 2511, 
2507, 2503, 2499, 2494, 2490, 2486, 2482, 2478, 2474, 2470, 2466, 2462, 2458, 2454, 2449, 2445, 2441, 2437, 2433, 2429, 2425, 2421, 2417, 2413, 2409, 2405, 2401, 2397, 2393, 2389, 2386, 2382, 
2378, 2374, 2370, 2366, 2362, 2358, 2354, 2350, 2346, 2343, 2339, 2335, 2331, 2327, 2323, 2319, 2316, 2312, 2308, 2304, 2300, 2297, 2293, 2289, 2285, 2281, 2278, 2274, 2270, 2266, 2263, 2259, 
2255, 2252, 2248, 2244, 2240, 2237, 2233, 2229, 2226, 2222, 2218, 2215, 2211, 2207, 2204, 2200, 2196, 2193, 2189, 2186, 2182, 2178, 2175, 2171, 2168, 2164, 2160, 2157, 2153, 2150, 2146, 2143, 
2139, 2136, 2132, 2128, 2125, 2121, 2118, 2114, 2111, 2107, 2104, 2100, 2097, 2094, 2090, 2087, 2083, 2080, 2076, 2073, 2069, 2066, 2062, 2059, 2056, 2052, 2049, 2045, 2042, 2039, 2035, 2032, 
2028, 2025, 2022, 2018, 2015, 2012, 2008, 2005, 2002, 1998, 1995, 1992, 1988, 1985, 1982, 1979, 1975, 1972, 1969, 1965, 1962, 1959, 1956, 1952, 1949, 1946, 1943, 1939, 1936, 1933, 1930, 1927, 
1923, 1920, 1917, 1914, 1910, 1907, 1904, 1901, 1898, 1895, 1891, 1888, 1885, 1882, 1879, 1876, 1872, 1869, 1866, 1863, 1860, 1857, 1854, 1851, 1848, 1845, 1841, 1838, 1835, 1832, 1829, 1826, 
1823, 1820, 1817, 1814, 1811, 1808, 1805, 1802, 1799, 1796, 1792, 1789, 1786, 1783, 1780, 1777, 1775, 1772, 1769, 1766, 1763, 1760, 1757, 1754, 1751, 1748, 1745, 1742, 1739, 1736, 1733, 1730, 
1727, 1724, 1721, 1718, 1715, 1712, 1710, 1707, 1704, 1701, 1698, 1695, 1692, 1689, 1687, 1684, 1681, 1678, 1675, 1672, 1669, 1667, 1664, 1661, 1658, 1655, 1652, 1650, 1647, 1644, 1641, 1638, 
1636, 1633, 1630, 1627, 1624, 1622, 1619, 1616, 1613, 1611, 1608, 1605, 1602, 1600, 1597, 1594, 1591, 1589, 1586, 1583, 1580, 1578, 1575, 1572, 1570, 1567, 1564, 1561, 1559, 1556, 1553, 1551, 
1548, 1545, 1543, 1540, 1537, 1535, 1532, 1529, 1527, 1524, 1521, 1519, 1516, 1514, 1511, 1508, 1506, 1503, 1501, 1498, 1495, 1493, 1490, 1487, 1485, 1482, 1480, 1477, 1475, 1472, 1470, 1467, 
1464, 1462, 1459, 1457, 1454, 1452, 1449, 1446, 1444, 1441, 1439, 1436, 1434, 1431, 1429, 1426, 1424, 1421, 1419, 1416, 1414, 1411, 1409, 1406, 1404, 1401, 1399, 1397, 1394, 1392, 1389, 1387, 
1384, 1382, 1379, 1377, 1374, 1372, 1370, 1367, 1365, 1362, 1360, 1357, 1355, 1353, 1350, 1348, 1345, 1343, 1341, 1338, 1336, 1333, 1331, 1329, 1326, 1324, 1321, 1319, 1317, 1314, 1312, 1310, 
1307, 1305, 1303, 1300, 1298, 1296, 1293, 1291, 1289, 1286, 1284, 1282, 1279, 1277, 1275, 1272, 1270, 1268, 1266, 1263, 1261, 1259, 1256, 1254, 1252, 1250, 1247, 1245, 1243, 1241, 1238, 1236, 
1234, 1231, 1229, 1227, 1225, 1223, 1220, 1218, 1216, 1214, 1211, 1209, 1207, 1205, 1202, 1200, 1198, 1196, 1194, 1191, 1189, 1187, 1185, 1183, 1181, 1178, 1176, 1174, 1172, 1170, 1167, 1165, 
1163, 1161, 1159, 1157, 1155, 1152, 1150, 1148, 1146, 1144, 1142, 1140, 1137, 1135, 1133, 1131, 1129, 1127, 1125, 1123, 1121, 1118, 1116, 1114, 1112, 1110, 1108, 1106, 1104, 1102, 1100, 1098, 
1096, 1093, 1091, 1089, 1087, 1085, 1083, 1081, 1079, 1077, 1075, 1073, 1071, 1069, 1067, 1065, 1063, 1061, 1059, 1057, 1055, 1053, 1051, 1049, 1047, 1045, 1043, 1041, 1039, 1037, 1035, 1033, 
1031, 1029, 1027, 1025, 1023, 1021, 1019, 1017, 1015, 1013, 1011, 1009, 1007, 1005, 1003, 1001, 999, 997, 995, 993, 991, 989, 988, 986, 984, 982, 980, 978, 976, 974, 972, 970, 
968, 966, 965, 963, 961, 959, 957, 955, 953, 951, 949, 948, 946, 944, 942, 940, 938, 936, 934, 933, 931, 929, 927, 925, 923, 921, 920, 918, 916, 914, 912, 910, 
909, 907, 905, 903, 901, 899, 898, 896, 894, 892, 890, 889, 887, 885, 883, 881, 880, 878, 876, 874, 872, 871, 869, 867, 865, 864, 862, 860, 858, 857, 855, 853, 
851, 850, 848, 846, 844, 843, 841, 839, 837, 836, 834, 832, 830, 829, 827, 825, 823, 822, 820, 818, 817, 815, 813, 811, 810, 808, 806, 805, 803, 801, 800, 798, 
796, 795, 793, 791, 790, 788, 786, 785, 783, 781, 780, 778, 776, 775, 773, 771, 770, 768, 766, 765, 763, 761, 760, 758, 756, 755, 753, 752, 750, 748, 747, 745, 
743, 742, 740, 739, 737, 735, 734, 732, 731, 729, 727, 726, 724, 723, 721, 719, 718, 716, 715, 713, 712, 710, 708, 707, 705, 704, 702, 701, 699, 697, 696, 694, 
693, 691, 690, 688, 687, 685, 684, 682, 681, 679, 677, 676, 674, 673, 671, 670, 668, 667, 665, 664, 662, 661, 659, 658, 656, 655, 653, 652, 650, 649, 647, 646, 
644, 643, 641, 640, 638, 637, 635, 634, 632, 631, 629, 628, 627, 625, 624, 622, 621, 619, 618, 616, 615, 613, 612, 611, 609, 608, 606, 605, 603, 602, 601, 599, 
598, 596, 595, 593, 592, 591, 589, 588, 586, 585, 583, 582, 581, 579, 578, 576, 575, 574, 572, 571, 570, 568, 567, 565, 564, 563, 561, 560, 558, 557, 556, 554, 
553, 552, 550, 549, 548, 546, 545, 543, 542, 541, 539, 538, 537, 535, 534, 533, 531, 530, 529, 527, 526, 525, 523, 522, 521, 519, 518, 517, 515, 514, 513, 511, 
510, 509, 508, 506, 505, 504, 502, 501, 500, 498, 497, 496, 495, 493, 492, 491, 489, 488, 487, 486, 484, 483, 482, 480, 479, 478, 477, 475, 474, 473, 472, 470, 
469, 468, 467, 465, 464, 463, 462, 460, 459, 458, 457, 455, 454, 453, 452, 450, 449, 448, 447, 446, 444, 443, 442, 441, 439, 438, 437, 436, 435, 433, 432, 431, 
430, 429, 427, 426, 425, 424, 423, 421, 420, 419, 418, 417, 416, 414, 413, 412, 411, 410, 408, 407, 406, 405, 404, 403, 401, 400, 399, 398, 397, 396, 395, 393, 
392, 391, 390, 389, 388, 386, 385, 384, 383, 382, 381, 380, 379, 377, 376, 375, 374, 373, 372, 371, 370, 368, 367, 366, 365, 364, 363, 362, 361, 359, 358, 357, 
356, 355, 354, 353, 352, 351, 350, 349, 347, 346, 345, 344, 343, 342, 341, 340, 339, 338, 337, 336, 334, 333, 332, 331, 330, 329, 328, 327, 326, 325, 324, 323, 
322, 321, 320, 319, 318, 317, 315, 314, 313, 312, 311, 310, 309, 308, 307, 306, 305, 304, 303, 302, 301, 300, 299, 298, 297, 296, 295, 294, 293, 292, 291, 290, 
289, 288, 287, 286, 285, 284, 283, 282, 281, 280, 279, 278, 277, 276, 275, 274, 273, 272, 271, 270, 269, 268, 267, 266, 265, 264, 263, 262, 261, 260, 259, 258, 
257, 256, 256, 255, 254, 253, 252, 251, 250, 249, 248, 247, 246, 245, 244, 243, 242, 241, 240, 239, 239, 238, 237, 236, 235, 234, 233, 232, 231, 230, 229, 228, 
227, 227, 226, 225, 224, 223, 222, 221, 220, 219, 218, 217, 217, 216, 215, 214, 213, 212, 211, 210, 209, 209, 208, 207, 206, 205, 204, 203, 202, 202, 201, 200, 
199, 198, 197, 196, 195, 195, 194, 193, 192, 191, 190, 189, 189, 188, 187, 186, 185, 184, 183, 183, 182, 181, 180, 179, 178, 178, 177, 176, 175, 174, 173, 173, 
172, 171, 170, 169, 168, 168, 167, 166, 165, 164, 163, 163, 162, 161, 160, 159, 159, 158, 157, 156, 155, 155, 154, 153, 152, 151, 151, 150, 149, 148, 147, 147, 
146, 145, 144, 143, 143, 142, 141, 140, 140, 139, 138, 137, 136, 136, 135, 134, 133, 133, 132, 131, 130, 130, 129, 128, 127, 126, 126, 125, 124, 123, 123, 122, 
121, 120, 120, 119, 118, 117, 117, 116, 115, 114, 114, 113, 112, 112, 111, 110, 109, 109, 108, 107, 106, 106, 105, 104, 104, 103, 102, 101, 101, 100, 99, 99, 
98, 97, 96, 96, 95, 94, 94, 93, 92, 92, 91, 90, 89, 89, 88, 87, 87, 86, 85, 85, 84, 83, 83, 82, 81, 80, 80, 79, 78, 78, 77, 76, 
76, 75, 74, 74, 73, 72, 72, 71, 70, 70, 69, 68, 68, 67, 66, 66, 65, 64, 64, 63, 63, 62, 61, 61, 60, 59, 59, 58, 57, 57, 56, 55, 
55, 54, 54, 53, 52, 52, 51, 50, 50, 49, 49, 48, 47, 47, 46, 45, 45, 44, 44, 43, 42, 42, 41, 41, 40, 39, 39, 38, 37, 37, 36, 36, 
35, 34, 34, 33, 33, 32, 32, 31, 30, 30, 29, 29, 28, 27, 27, 26, 26, 25, 24, 24, 23, 23, 22, 22, 21, 20, 20, 19, 19, 18, 18, 17, 
16, 16, 15, 15, 14, 14, 13, 13, 12, 11, 11, 10, 10, 9, 9, 8, 8, 7, 6, 6, 5, 5, 4, 4, 3, 3, 2, 2, 1, 1, 0, 0, 
};

#define USE_CYCLE_SINE_TBL  defined
static float cycle_sine_tbl_f[16384];


static const char *ST_PLUGIN_API loc_get_param_name(st_plugin_info_t *_info,
                                                    unsigned int      _paramIdx
                                                    ) {
   (void)_info;
   return loc_param_names[_paramIdx];
}

static float ST_PLUGIN_API loc_get_param_reset(st_plugin_info_t *_info,
                                               unsigned int      _paramIdx
                                               ) {
   (void)_info;
   return loc_param_resets[_paramIdx];
}

static float ST_PLUGIN_API loc_get_param_value(st_plugin_shared_t *_shared,
                                               unsigned int        _paramIdx
                                               ) {
   ST_PLUGIN_SHARED_CAST(curve_dev_shared_t);
   return shared->params[_paramIdx];
}

static void ST_PLUGIN_API loc_set_param_value(st_plugin_shared_t *_shared,
                                              unsigned int        _paramIdx,
                                              float               _value
                                              ) {
   ST_PLUGIN_SHARED_CAST(curve_dev_shared_t);
   shared->params[_paramIdx] = _value;
}

static const char *ST_PLUGIN_API loc_get_mod_name(st_plugin_info_t *_info,
                                                  unsigned int      _modIdx
                                                  ) {
   (void)_info;
   return loc_mod_names[_modIdx];
}

static void ST_PLUGIN_API loc_set_sample_rate(st_plugin_voice_t *_voice,
                                              float              _sampleRate
                                              ) {
   ST_PLUGIN_VOICE_CAST(curve_dev_voice_t);
   voice->sample_rate = _sampleRate;
}

static void ST_PLUGIN_API loc_note_on(st_plugin_voice_t  *_voice,
                                      int                 _bGlide,
                                      unsigned char       _note,
                                      float               _vel
                                      ) {
   ST_PLUGIN_VOICE_CAST(curve_dev_voice_t);
   ST_PLUGIN_VOICE_SHARED_CAST(curve_dev_shared_t);
   (void)_bGlide;
   (void)_note;
   (void)_vel;
   if(!_bGlide)
   {
      memset((void*)voice->mods, 0, sizeof(voice->mods));
#ifdef OVERSAMPLE_FACTOR
      voice->note_speed_fixed = (0.5f / (voice->sample_rate * OVERSAMPLE_FACTOR));
#else
      voice->note_speed_fixed = (0.5f / voice->sample_rate);
#endif // OVERSAMPLE_FACTOR


      voice->tmp1_sin_phase = 0.0f;

      voice->var_x = 0.0f;


   }
}

static void ST_PLUGIN_API loc_set_mod_value(st_plugin_voice_t *_voice,
                                            unsigned int       _modIdx,
                                            float              _value,
                                            unsigned           _frameOffset
                                            ) {
   ST_PLUGIN_VOICE_CAST(curve_dev_voice_t);
   (void)_frameOffset;
   voice->mods[_modIdx] = _value;
}

static void ST_PLUGIN_API loc_prepare_block(st_plugin_voice_t *_voice,
                                            unsigned int       _numFrames,
                                            float              _freqHz,
                                            float              _note,
                                            float              _vol,
                                            float              _pan
                                            ) {
   ST_PLUGIN_VOICE_CAST(curve_dev_voice_t);
   ST_PLUGIN_VOICE_SHARED_CAST(curve_dev_shared_t);
   (void)_note;
   (void)_vol;
   (void)_pan;

#ifdef OVERSAMPLE_FACTOR
   float noteSpeed = _freqHz / (voice->sample_rate * OVERSAMPLE_FACTOR);
#else
   float noteSpeed = _freqHz / voice->sample_rate;
#endif // OVERSAMPLE_FACTOR


   if(_numFrames > 0u)
   {
      // lerp
      float recBlockSize = (1.0f / _numFrames);
      voice->note_speed_inc = (noteSpeed - voice->note_speed_cur) * recBlockSize;
      voice->note_inc       = (_note - voice->note_cur) * recBlockSize;

   
   }
   else
   {
      // initial params/modulation (first block, not rendered)
      voice->note_speed_cur = noteSpeed;
      voice->note_speed_inc = 0.0f;
      voice->note_cur       = _note;
      voice->note_inc       = 0.0f;

   
   }

   // printf("xxx note_cur=%f\n", voice->note_cur);
}

static void ST_PLUGIN_API loc_process_replace(st_plugin_voice_t  *_voice,
                                              int                 _bMonoIn,
                                              const float        *_samplesIn,
                                              float              *_samplesOut, 
                                              unsigned int        _numFrames
                                              ) {
   (void)_bMonoIn;
   (void)_samplesIn;

   ST_PLUGIN_VOICE_CAST(curve_dev_voice_t);
   ST_PLUGIN_VOICE_SHARED_CAST(curve_dev_shared_t);

   // Mono output (replicate left to right channel)
   unsigned int j = 0u;
   unsigned int jStep = _bMonoIn ? 1u : 2u;
   unsigned int k = 0u;
   for(unsigned int i = 0u; i < _numFrames; i++)
   {
      float out = _samplesIn[j];
      j += jStep;
#ifdef OVERSAMPLE_FACTOR
      float outOS = 0.0f;
#endif // OVERSAMPLE_FACTOR

#ifdef OVERSAMPLE_FACTOR
      for(unsigned int osi = 0u; osi < OVERSAMPLE_FACTOR; osi++)
#endif // OVERSAMPLE_FACTOR
      {
      float tmp_f;
      float tmp2_f;
      
      // ========
      // ======== lane "out" modIdx=0
      // ========
      
      // -- mod="sin" dstVar=out
      voice->tmp3_freq = 1;
      voice->tmp2_sin_speed = voice->note_speed_cur * voice->tmp3_freq;
      voice->tmp4_sin_tmp = (voice->tmp1_sin_phase);
      voice->tmp4_sin_tmp = ffrac_s(voice->tmp4_sin_tmp);
      out = cycle_sine_tbl_f[(unsigned short)(16384 * voice->tmp4_sin_tmp)&16383u];
      voice->tmp1_sin_phase = ffrac_s(voice->tmp1_sin_phase + voice->tmp2_sin_speed);

      /* end calc */

#ifdef OVERSAMPLE_FACTOR
         outOS += out;
#endif // OVERSAMPLE_FACTOR
      }
#ifdef OVERSAMPLE_FACTOR
      // Apply lowpass filter before downsampling
      //   (note) normalized Fc = F/Fs = 0.442947 / sqrt(oversample_factor - 1)
      out = outOS * (1.0f / OVERSAMPLE_FACTOR);
#endif // OVERSAMPLE_FACTOR
      _samplesOut[k]      = out;
      _samplesOut[k + 1u] = out;

      // Next frame
      k += 2u;
      voice->note_speed_cur += voice->note_speed_inc;
   } /* loop numFrames */
}

static st_plugin_shared_t *ST_PLUGIN_API loc_shared_new(st_plugin_info_t *_info) {
   curve_dev_shared_t *ret = (curve_dev_shared_t *)malloc(sizeof(curve_dev_shared_t));
   if(NULL != ret)
   {
      memset((void*)ret, 0, sizeof(*ret));
      ret->base.info  = _info;
      memcpy((void*)ret->params, (void*)loc_param_resets, NUM_PARAMS * sizeof(float));
   }
   return &ret->base;
}

static void ST_PLUGIN_API loc_shared_delete(st_plugin_shared_t *_shared) {
   free((void*)_shared);
}

static st_plugin_voice_t *ST_PLUGIN_API loc_voice_new(st_plugin_info_t *_info) {
   curve_dev_voice_t *voice = (curve_dev_voice_t *)malloc(sizeof(curve_dev_voice_t));
   if(NULL != voice)
   {
      memset((void*)voice, 0, sizeof(*voice));
      voice->base.info = _info;
   }
   return &voice->base;
}

static void ST_PLUGIN_API loc_voice_delete(st_plugin_voice_t *_voice) {
   ST_PLUGIN_VOICE_CAST(curve_dev_voice_t);

   free((void*)_voice);
}

static void ST_PLUGIN_API loc_plugin_exit(st_plugin_info_t *_info) {
   free((void*)_info);
}

#ifdef USE_CYCLE_SINE_TBL
static void loc_calc_sine_tbl(void) {
#define QCOS_BITS 16
#define QCOS_ONE  (1 << QCOS_BITS)
#define QCOS_MASK (QCOS_ONE - 1)
   // (note) same as in TSR "C" implementation
   float *qcos = cycle_sine_tbl_f + 4096; // quarter cos tbl

   // calc quarter cos tbl
   int k = 0;
   for(int a = 0; a < (QCOS_ONE/4); a += (QCOS_ONE/16384)/*4*/)  // 4096 elements
   {
      int x = a - ((int)(QCOS_ONE * 0.25 + 0.5)) + ((a + ((int)(QCOS_ONE * 0.25 + 0.5)))&~QCOS_MASK);
      x = ((x * ((x<0?-x:x) - ((int)(QCOS_ONE * 0.5 + 0.5)))) >> QCOS_BITS) << 4;
      x += (((((int)(QCOS_ONE * 0.225 + 0.5)) * x) >> QCOS_BITS) * ((x<0?-x:x) - QCOS_ONE)) >> QCOS_BITS;
      qcos[k++] = x / float(QCOS_ONE);
   }

   // 0..90 (rev qtbl)
   int j = 4096;
   k = 0;
   loop(4096)
      cycle_sine_tbl_f[k++] = qcos[--j];

   // 90..180 = cos tbl
   k += 4096;

   // 180..360 (y-flip first half of tbl)
   j = 0;
   loop(8192)
      cycle_sine_tbl_f[k++] = -cycle_sine_tbl_f[j++];

#ifdef USE_CYCLE_SINE_TBL_I
   loop(16384)
      cycle_sine_tbl_i[i] = (short)(cycle_sine_tbl_f[i] * 2048.0f/*FX_ONE*/);
#endif // USE_CYCLE_SINE_TBL_I
}
#endif // USE_CYCLE_SINE_TBL

extern "C" {
st_plugin_info_t *curve_dev_init(void) {
   curve_dev_info_t *ret = (curve_dev_info_t *)malloc(sizeof(curve_dev_info_t));

   if(NULL != ret)
   {
      memset(ret, 0, sizeof(*ret));

      ret->base.api_version = ST_PLUGIN_API_VERSION;
      ret->base.id          = "curve_dev";  // unique id. don't change this in future builds.
      ret->base.author      = "bsp";
      ret->base.name        = "curve dev";
      ret->base.short_name  = "curve dev";
      ret->base.flags       = ST_PLUGIN_FLAG_OSC;
      ret->base.category    = ST_PLUGIN_CAT_UNKNOWN;
      ret->base.num_params  = NUM_PARAMS;
      ret->base.num_mods    = NUM_MODS;

      ret->base.shared_new       = &loc_shared_new;
      ret->base.shared_delete    = &loc_shared_delete;
      ret->base.voice_new        = &loc_voice_new;
      ret->base.voice_delete     = &loc_voice_delete;
      ret->base.get_param_name   = &loc_get_param_name;
      ret->base.get_param_reset  = &loc_get_param_reset;
      ret->base.get_param_value  = &loc_get_param_value;
      ret->base.set_param_value  = &loc_set_param_value;
      ret->base.get_mod_name     = &loc_get_mod_name;
      ret->base.set_sample_rate  = &loc_set_sample_rate;
      ret->base.note_on          = &loc_note_on;
      ret->base.set_mod_value    = &loc_set_mod_value;
      ret->base.prepare_block    = &loc_prepare_block;
      ret->base.process_replace  = &loc_process_replace;
      ret->base.plugin_exit      = &loc_plugin_exit;

#ifdef USE_CYCLE_SINE_TBL
      loc_calc_sine_tbl();
#endif // USE_CYCLE_SINE_TBL
   }

   return &ret->base;
}

#ifndef STFX_SKIP_MAIN_INIT
ST_PLUGIN_APICALL st_plugin_info_t *ST_PLUGIN_API st_plugin_init(unsigned int _pluginIdx) {
   switch(_pluginIdx)
   {
      case 0u:
         return curve_dev_init();
   }
   return NULL;
}
#endif // STFX_SKIP_MAIN_INIT

} // extern "C"
