// ----
// ---- file   : osc_fm3s_fb.cpp
// ---- author : bsp
// ---- legal  : Distributed under terms of the MIT license (https://opensource.org/licenses/MIT)
// ----
// ----          Permission is hereby granted, free of charge, to any person obtaining a copy of this software and 
// ----          associated documentation files (the "Software"), to deal in the Software without restriction, including 
// ----          without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell 
// ----          copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to 
// ----          the following conditions:
// ----  
// ----          The above copyright notice and this permission notice shall be included in all copies or substantial 
// ----          portions of the Software.
// ----
// ----          THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT
// ----          NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
// ----          IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
// ----          WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE 
// ----          SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
// ----
// ---- info   : auto-generated by "Cycle"
// ----           $ g++ -Wall -Wno-unused-function -Wno-unused-variable -I../../tksampler -c osc_fm3s_fb.cpp -o osc_fm3s_fb.o
// ---- created: 11Nov2023 19:16:38
// ----
// ----
// ----

#include <plugin.h>

#include <stdlib.h>
#include <math.h>
#include <string.h>


#define OVERSAMPLE_FACTOR  16.0f

#define PARAM_FB_1               0
#define PARAM_FB_2               1
#define PARAM_FB_3               2
#define PARAM_PHASE_RAND         3
#define PARAM_RATIO_2            4
#define PARAM_RATIO_3            5
#define PARAM_LEVEL_2            6
#define PARAM_LEVEL_3            7
#define NUM_PARAMS               8
static const char *loc_param_names[NUM_PARAMS] = {
   "fb_1",                    // 0: FB_1
   "fb_2",                    // 1: FB_2
   "fb_3",                    // 2: FB_3
   "phase_rand",              // 3: PHASE_RAND
   "ratio_2",                 // 4: RATIO_2
   "ratio_3",                 // 5: RATIO_3
   "level_2",                 // 6: LEVEL_2
   "level_3",                 // 7: LEVEL_3

};
static float loc_param_resets[NUM_PARAMS] = {
   0.0f,                      // 0: FB_1
   0.0f,                      // 1: FB_2
   0.0f,                      // 2: FB_3
   0.0f,                      // 3: PHASE_RAND
   0.5f,                      // 4: RATIO_2
   0.5f,                      // 5: RATIO_3
   0.0f,                      // 6: LEVEL_2
   0.0f,                      // 7: LEVEL_3

};

#define MOD_FB_1                 0
#define MOD_FB_2                 1
#define MOD_FB_3                 2
#define MOD_INIT                 3
#define MOD_RATIO_2              4
#define MOD_RATIO_3              5
#define MOD_LEVEL_2              6
#define MOD_LEVEL_3              7
#define NUM_MODS                 8
static const char *loc_mod_names[NUM_MODS] = {
   "fb_1",         // 0: FB_1
   "fb_2",         // 1: FB_2
   "fb_3",         // 2: FB_3
   "init",         // 3: INIT
   "ratio_2",      // 4: RATIO_2
   "ratio_3",      // 5: RATIO_3
   "level_2",      // 6: LEVEL_2
   "level_3",      // 7: LEVEL_3

};

typedef struct osc_fm3s_fb_info_s {
   st_plugin_info_t base;
} osc_fm3s_fb_info_t;

typedef struct osc_fm3s_fb_shared_s {
   st_plugin_shared_t base;
   float params[NUM_PARAMS];

} osc_fm3s_fb_shared_t;

typedef struct osc_fm3s_fb_voice_s {
   st_plugin_voice_t base;
   float             sample_rate;
   float             note_speed_fixed;
   float             note_speed_cur;
   float             note_speed_inc;
   float             note_cur;
   float             note_inc;
   float             mods[NUM_MODS];
   float mod_fb_1_cur;
   float mod_fb_1_inc;
   float mod_fb_2_cur;
   float mod_fb_2_inc;
   float mod_fb_3_cur;
   float mod_fb_3_inc;
   float mod_init_cur;
   float mod_init_inc;
   float mod_ratio_2_cur;
   float mod_ratio_2_inc;
   float mod_ratio_3_cur;
   float mod_ratio_3_inc;
   float mod_level_2_cur;
   float mod_level_2_inc;
   float mod_level_3_cur;
   float mod_level_3_inc;

   short tmp1_i2f;
   unsigned short tmp2_lfsr_state;
   short tmp3_lfsr_state_signed;
   float tmp4_seq;
   short tmp5_i2f;
   unsigned short tmp6_lfsr_state;
   short tmp7_lfsr_state_signed;
   float tmp8_seq;
   short tmp9_i2f;
   unsigned short tmp10_lfsr_state;
   short tmp11_lfsr_state_signed;
   float tmp12_seq;
   float tmp13_seq;
   float tmp14_seq;
   float tmp15_seq;
   float tmp16_seq;
   float tmp17_seq;
   float tmp18_seq;
   float tmp19_seq;
   float tmp20_seq;
   float tmp21_seq;
   float tmp22_seq;
   float tmp23_sin_phase;
   float tmp24_sin_speed;
   float tmp25_freq;
   float tmp26_sin_tmp;
   float tmp27_phase;
   float tmp28_seq;
   float tmp29_seq;
   float tmp30_seq;
   float tmp31_sin_phase;
   float tmp32_sin_speed;
   float tmp33_freq;
   float tmp34_sin_tmp;
   float tmp35_phase;
   float tmp36_seq;
   float tmp37_seq;
   float tmp38_seq;
   float tmp39_seq;
   float tmp40_sin_phase;
   float tmp41_sin_speed;
   float tmp42_freq;
   float tmp43_sin_tmp;
   float tmp44_phase;
   float tmp45_seq;
   float tmp46_seq;
   float var_x;
   float var_v_fb_1;
   float var_v_fb_2;
   float var_v_fb_3;
   float var_v_level_2;
   float var_v_level_3;
   float var_v_freq_2;
   float var_v_freq_3;
   float var_v_osc_1;
   float var_v_osc_2;
   float var_v_osc_3;
   float var_v_phrand_1;
   float var_v_phrand_2;
   float var_v_phrand_3;

} osc_fm3s_fb_voice_t;

#define loop(X)  for(unsigned int i = 0u; i < (X); i++)
#define clamp(a,b,c) (((a)<(b))?(b):(((a)>(c))?(c):(a)))

static inline float mathLerpf(float _a, float _b, float _t) { return _a + (_b - _a) * _t; }
static inline float mathClampf(float a, float b, float c) { return (((a)<(b))?(b):(((a)>(c))?(c):(a))); }
static inline float mathMinf(float a, float b) { return (a<b)?a:b; }
static inline float mathMaxf(float a, float b) { return (a>b)?a:b; }
static inline float mathAbsMaxf(float _x, float _y) { return ( ( (_x<0.0f)?-_x:_x)>((_y<0.0f)?-_y:_y)?_x:_y ); }
static inline float mathAbsMinf(float _x, float _y) { return ( ((_x<0.0f)?-_x:_x)<((_y<0.0f)?-_y:_y)?_x:_y ); }

static inline float winLinear(const float *_s, float _index) {
   int idx = (int)_index;
   float r = _index - (float)idx;
   return mathLerpf(_s[idx], _s[idx+1], r);
}

static float ffrac_s(float _f) { int i; if(_f >= 0.0f) { i = (int)_f; return _f - (float)i; } else { i = (int)-_f; return 1.0f - (-_f - (float)i); } }

#define USE_CYCLE_SINE_TBL  defined
static float cycle_sine_tbl_f[16384];

static float loc_bipolar_to_scale(const float _t, const float _div, const float _mul) {
   // t (-1..1) => /_div .. *_mul
   
   float s;

   if(_t < 0.0f)
   {
      s = (1.0f / _div);
      s = 1.0f + (s - 1.0f) * -_t;
      if(s < 0.0f)
         s = 0.0f;
   }
   else
   {
      s = _mul;
      s = 1.0f + (s - 1.0f) * _t;
   }
   
   return s;
}

static void loc_init(st_plugin_voice_t *_voice);
static void loc_prepare(st_plugin_voice_t *_voice);

void loc_init(st_plugin_voice_t *_voice) {
   ST_PLUGIN_VOICE_CAST(osc_fm3s_fb_voice_t);
   ST_PLUGIN_VOICE_SHARED_CAST(osc_fm3s_fb_shared_t);

   float out = 0.0f;
   // -------- lane "init" modIdx=0
   
   // -- mod="fsr" dstVar=out
   voice->tmp1_i2f = (int)(out * 2048);  // IntFallback: F2I
   voice->tmp2_lfsr_state ^= voice->tmp2_lfsr_state >> 7;
   voice->tmp2_lfsr_state ^= voice->tmp2_lfsr_state << 9;
   voice->tmp2_lfsr_state ^= voice->tmp2_lfsr_state >> 13;
   voice->tmp3_lfsr_state_signed = (voice->tmp2_lfsr_state & 65520);
   voice->tmp1_i2f = voice->tmp3_lfsr_state_signed >> 4;
   out = voice->tmp1_i2f / ((float)(2048));  // IntFallback: I2F
   
   // -- mod="$p_phase_rand" dstVar=out
   voice->tmp4_seq = shared->params[PARAM_PHASE_RAND];
   out *= voice->tmp4_seq;
   
   // -- mod="sto v_phrand_1" dstVar=out
   voice->var_v_phrand_1 = out;
   
   // -- mod="fsr" dstVar=out
   voice->tmp5_i2f = (int)(out * 2048);  // IntFallback: F2I
   voice->tmp6_lfsr_state ^= voice->tmp6_lfsr_state >> 7;
   voice->tmp6_lfsr_state ^= voice->tmp6_lfsr_state << 9;
   voice->tmp6_lfsr_state ^= voice->tmp6_lfsr_state >> 13;
   voice->tmp7_lfsr_state_signed = (voice->tmp6_lfsr_state & 65520);
   voice->tmp5_i2f = voice->tmp7_lfsr_state_signed >> 4;
   out = voice->tmp5_i2f / ((float)(2048));  // IntFallback: I2F
   
   // -- mod="$p_phase_rand" dstVar=out
   voice->tmp8_seq = shared->params[PARAM_PHASE_RAND];
   out *= voice->tmp8_seq;
   
   // -- mod="sto v_phrand_2" dstVar=out
   voice->var_v_phrand_2 = out;
   
   // -- mod="fsr" dstVar=out
   voice->tmp9_i2f = (int)(out * 2048);  // IntFallback: F2I
   voice->tmp10_lfsr_state ^= voice->tmp10_lfsr_state >> 7;
   voice->tmp10_lfsr_state ^= voice->tmp10_lfsr_state << 9;
   voice->tmp10_lfsr_state ^= voice->tmp10_lfsr_state >> 13;
   voice->tmp11_lfsr_state_signed = (voice->tmp10_lfsr_state & 65520);
   voice->tmp9_i2f = voice->tmp11_lfsr_state_signed >> 4;
   out = voice->tmp9_i2f / ((float)(2048));  // IntFallback: I2F
   
   // -- mod="$p_phase_rand" dstVar=out
   voice->tmp12_seq = shared->params[PARAM_PHASE_RAND];
   out *= voice->tmp12_seq;
   
   // -- mod="sto v_phrand_3" dstVar=out
   voice->var_v_phrand_3 = out;
   
   // -- mod="$v_osc_1" dstVar=out
   out = voice->var_v_osc_1;
   
   // -- mod="$m_init" dstVar=out
   voice->tmp13_seq = voice->mod_init_cur;
   
   // -- mod="0.01" dstVar=voice->tmp13_seq
   voice->tmp14_seq = 0.01f;
   voice->tmp13_seq *= voice->tmp14_seq;
   out *= voice->tmp13_seq;
   
   // -- mod="sto v_osc_1" dstVar=out
   voice->var_v_osc_1 = out;
   
   // -- mod="$v_osc_2" dstVar=out
   out = voice->var_v_osc_2;
   
   // -- mod="$m_init" dstVar=out
   voice->tmp15_seq = voice->mod_init_cur;
   
   // -- mod="0.01" dstVar=voice->tmp15_seq
   voice->tmp16_seq = 0.01f;
   voice->tmp15_seq *= voice->tmp16_seq;
   out *= voice->tmp15_seq;
   
   // -- mod="sto v_osc_2" dstVar=out
   voice->var_v_osc_2 = out;
   
   // -- mod="$v_osc_3" dstVar=out
   out = voice->var_v_osc_3;
   
   // -- mod="$m_init" dstVar=out
   voice->tmp17_seq = voice->mod_init_cur;
   
   // -- mod="0.01" dstVar=voice->tmp17_seq
   voice->tmp18_seq = 0.01f;
   voice->tmp17_seq *= voice->tmp18_seq;
   out *= voice->tmp17_seq;
   
   // -- mod="sto v_osc_3" dstVar=out
   voice->var_v_osc_3 = out;
} /* end init */

void loc_prepare(st_plugin_voice_t *_voice) {
   ST_PLUGIN_VOICE_CAST(osc_fm3s_fb_voice_t);
   ST_PLUGIN_VOICE_SHARED_CAST(osc_fm3s_fb_shared_t);

   float out = 0.0f;
   // -------- lane "prepare" modIdx=0
   
   // -- mod="$m_ratio_2" dstVar=out
   out = voice->mod_ratio_2_cur;
   
   // -- mod="fma" dstVar=out
   out = (out * 2.0f) + -1.0f;
   
   // -- mod="bts" dstVar=out
   out = loc_bipolar_to_scale(out, 4096.0f, 4.0f);
   
   // -- mod="pow" dstVar=out
   out = out * out * out;
   
   // -- mod="qua" dstVar=out
   out = ((int)(out * 100.0f) / 100.0f);
   
   // -- mod="sto v_freq_2" dstVar=out
   voice->var_v_freq_2 = out;
   
   // -- mod="$m_ratio_3" dstVar=out
   out = voice->mod_ratio_3_cur;
   
   // -- mod="fma" dstVar=out
   out = (out * 2.0f) + -1.0f;
   
   // -- mod="bts" dstVar=out
   out = loc_bipolar_to_scale(out, 4096.0f, 4.0f);
   
   // -- mod="pow" dstVar=out
   out = out * out * out;
   
   // -- mod="qua" dstVar=out
   out = ((int)(out * 100.0f) / 100.0f);
   
   // -- mod="sto v_freq_3" dstVar=out
   voice->var_v_freq_3 = out;
   
   // -- mod="$m_fb_1" dstVar=out
   out = voice->mod_fb_1_cur;
   
   // -- mod="sto v_fb_1" dstVar=out
   voice->var_v_fb_1 = out;
   
   // -- mod="$m_fb_2" dstVar=out
   out = voice->mod_fb_2_cur;
   
   // -- mod="4" dstVar=out
   voice->tmp19_seq = 4.0f;
   out *= voice->tmp19_seq;
   
   // -- mod="sto v_fb_2" dstVar=out
   voice->var_v_fb_2 = out;
   
   // -- mod="$m_fb_3" dstVar=out
   out = voice->mod_fb_3_cur;
   
   // -- mod="4" dstVar=out
   voice->tmp20_seq = 4.0f;
   out *= voice->tmp20_seq;
   
   // -- mod="sto v_fb_3" dstVar=out
   voice->var_v_fb_3 = out;
} /* end prepare */

static const char *ST_PLUGIN_API loc_get_param_name(st_plugin_info_t *_info,
                                                    unsigned int      _paramIdx
                                                    ) {
   (void)_info;
   return loc_param_names[_paramIdx];
}

static float ST_PLUGIN_API loc_get_param_reset(st_plugin_info_t *_info,
                                               unsigned int      _paramIdx
                                               ) {
   (void)_info;
   return loc_param_resets[_paramIdx];
}

static float ST_PLUGIN_API loc_get_param_value(st_plugin_shared_t *_shared,
                                               unsigned int        _paramIdx
                                               ) {
   ST_PLUGIN_SHARED_CAST(osc_fm3s_fb_shared_t);
   return shared->params[_paramIdx];
}

static void ST_PLUGIN_API loc_set_param_value(st_plugin_shared_t *_shared,
                                              unsigned int        _paramIdx,
                                              float               _value
                                              ) {
   ST_PLUGIN_SHARED_CAST(osc_fm3s_fb_shared_t);
   shared->params[_paramIdx] = _value;
}

static const char *ST_PLUGIN_API loc_get_mod_name(st_plugin_info_t *_info,
                                                  unsigned int      _modIdx
                                                  ) {
   (void)_info;
   return loc_mod_names[_modIdx];
}

static void ST_PLUGIN_API loc_set_sample_rate(st_plugin_voice_t *_voice,
                                              float              _sampleRate
                                              ) {
   ST_PLUGIN_VOICE_CAST(osc_fm3s_fb_voice_t);
   voice->sample_rate = _sampleRate;
}

static void ST_PLUGIN_API loc_note_on(st_plugin_voice_t  *_voice,
                                      int                 _bGlide,
                                      unsigned char       _note,
                                      float               _vel
                                      ) {
   ST_PLUGIN_VOICE_CAST(osc_fm3s_fb_voice_t);
   ST_PLUGIN_VOICE_SHARED_CAST(osc_fm3s_fb_shared_t);
   (void)_bGlide;
   (void)_note;
   (void)_vel;
   if(!_bGlide)
   {
      memset((void*)voice->mods, 0, sizeof(voice->mods));
#ifdef OVERSAMPLE_FACTOR
      voice->note_speed_fixed = (0.5f / (voice->sample_rate * OVERSAMPLE_FACTOR));
#else
      voice->note_speed_fixed = (0.5f / voice->sample_rate);
#endif // OVERSAMPLE_FACTOR


      voice->tmp3_lfsr_state_signed = 0;
      voice->tmp7_lfsr_state_signed = 0;
      voice->tmp11_lfsr_state_signed = 0;
      voice->tmp23_sin_phase = 0.0f;
      voice->tmp31_sin_phase = 0.0f;
      voice->tmp40_sin_phase = 0.0f;

      voice->var_x = 0.0f;
      voice->var_v_fb_1 = 0.0f;
      voice->var_v_fb_2 = 0.0f;
      voice->var_v_fb_3 = 0.0f;
      voice->var_v_level_2 = 0.0f;
      voice->var_v_level_3 = 0.0f;
      voice->var_v_freq_2 = 0.0f;
      voice->var_v_freq_3 = 0.0f;
      voice->var_v_osc_1 = 0.0f;
      voice->var_v_osc_2 = 0.0f;
      voice->var_v_osc_3 = 0.0f;
      voice->var_v_phrand_1 = 0.0f;
      voice->var_v_phrand_2 = 0.0f;
      voice->var_v_phrand_3 = 0.0f;

      loc_init(&voice->base);

   }
}

static void ST_PLUGIN_API loc_set_mod_value(st_plugin_voice_t *_voice,
                                            unsigned int       _modIdx,
                                            float              _value,
                                            unsigned           _frameOffset
                                            ) {
   ST_PLUGIN_VOICE_CAST(osc_fm3s_fb_voice_t);
   (void)_frameOffset;
   voice->mods[_modIdx] = _value;
}

static void ST_PLUGIN_API loc_prepare_block(st_plugin_voice_t *_voice,
                                            unsigned int       _numFrames,
                                            float              _freqHz,
                                            float              _note,
                                            float              _vol,
                                            float              _pan
                                            ) {
   ST_PLUGIN_VOICE_CAST(osc_fm3s_fb_voice_t);
   ST_PLUGIN_VOICE_SHARED_CAST(osc_fm3s_fb_shared_t);
   (void)_note;
   (void)_vol;
   (void)_pan;

#ifdef OVERSAMPLE_FACTOR
   float noteSpeed = _freqHz / (voice->sample_rate * OVERSAMPLE_FACTOR);
#else
   float noteSpeed = _freqHz / voice->sample_rate;
#endif // OVERSAMPLE_FACTOR

   float modfb_1         = shared->params[PARAM_FB_1        ]                       + voice->mods[MOD_FB_1         ];
   float modfb_2         = shared->params[PARAM_FB_2        ]                       + voice->mods[MOD_FB_2         ];
   float modfb_3         = shared->params[PARAM_FB_3        ]                       + voice->mods[MOD_FB_3         ];
   float modinit         = voice->mods[MOD_INIT         ];
   float modratio_2      = shared->params[PARAM_RATIO_2     ]                       + voice->mods[MOD_RATIO_2      ];
   float modratio_3      = shared->params[PARAM_RATIO_3     ]                       + voice->mods[MOD_RATIO_3      ];
   float modlevel_2      = shared->params[PARAM_LEVEL_2     ]                       + voice->mods[MOD_LEVEL_2      ];
   float modlevel_3      = shared->params[PARAM_LEVEL_3     ]                       + voice->mods[MOD_LEVEL_3      ];

   if(_numFrames > 0u)
   {
      // lerp
      float recBlockSize = (1.0f / _numFrames);
      voice->note_speed_inc = (noteSpeed - voice->note_speed_cur) * recBlockSize;
      voice->note_inc       = (_note - voice->note_cur) * recBlockSize;
      voice->mod_fb_1_inc         = (modfb_1            - voice->mod_fb_1_cur          ) * recBlockSize;
      voice->mod_fb_2_inc         = (modfb_2            - voice->mod_fb_2_cur          ) * recBlockSize;
      voice->mod_fb_3_inc         = (modfb_3            - voice->mod_fb_3_cur          ) * recBlockSize;
      voice->mod_init_inc         = (modinit            - voice->mod_init_cur          ) * recBlockSize;
      voice->mod_ratio_2_inc      = (modratio_2         - voice->mod_ratio_2_cur       ) * recBlockSize;
      voice->mod_ratio_3_inc      = (modratio_3         - voice->mod_ratio_3_cur       ) * recBlockSize;
      voice->mod_level_2_inc      = (modlevel_2         - voice->mod_level_2_cur       ) * recBlockSize;
      voice->mod_level_3_inc      = (modlevel_3         - voice->mod_level_3_cur       ) * recBlockSize;

      loc_prepare(&voice->base);
   }
   else
   {
      // initial params/modulation (first block, not rendered)
      voice->note_speed_cur = noteSpeed;
      voice->note_speed_inc = 0.0f;
      voice->note_cur       = _note;
      voice->note_inc       = 0.0f;
      voice->mod_fb_1_cur         = modfb_1;
      voice->mod_fb_1_inc         = 0.0f;
      voice->mod_fb_2_cur         = modfb_2;
      voice->mod_fb_2_inc         = 0.0f;
      voice->mod_fb_3_cur         = modfb_3;
      voice->mod_fb_3_inc         = 0.0f;
      voice->mod_init_cur         = modinit;
      voice->mod_init_inc         = 0.0f;
      voice->mod_ratio_2_cur      = modratio_2;
      voice->mod_ratio_2_inc      = 0.0f;
      voice->mod_ratio_3_cur      = modratio_3;
      voice->mod_ratio_3_inc      = 0.0f;
      voice->mod_level_2_cur      = modlevel_2;
      voice->mod_level_2_inc      = 0.0f;
      voice->mod_level_3_cur      = modlevel_3;
      voice->mod_level_3_inc      = 0.0f;

      loc_prepare(&voice->base);
   }

   // printf("xxx note_cur=%f\n", voice->note_cur);
}

static void ST_PLUGIN_API loc_process_replace(st_plugin_voice_t  *_voice,
                                              int                 _bMonoIn,
                                              const float        *_samplesIn,
                                              float              *_samplesOut, 
                                              unsigned int        _numFrames
                                              ) {
   (void)_bMonoIn;
   (void)_samplesIn;

   ST_PLUGIN_VOICE_CAST(osc_fm3s_fb_voice_t);
   ST_PLUGIN_VOICE_SHARED_CAST(osc_fm3s_fb_shared_t);

   // Mono output (replicate left to right channel)
   unsigned int j = 0u;
   unsigned int jStep = _bMonoIn ? 1u : 2u;
   unsigned int k = 0u;
   for(unsigned int i = 0u; i < _numFrames; i++)
   {
      float out = _samplesIn[j];
      j += jStep;
#ifdef OVERSAMPLE_FACTOR
      float outOS = 0.0f;
#endif // OVERSAMPLE_FACTOR

#ifdef OVERSAMPLE_FACTOR
      for(unsigned int osi = 0u; osi < OVERSAMPLE_FACTOR; osi++)
#endif // OVERSAMPLE_FACTOR
      {
         float tmp_f;
         float tmp2_f;
         
         // ========
         // ======== lane "out" modIdx=0
         // ========
         
         // -- mod="$m_level_2" dstVar=out
         out = voice->mod_level_2_cur;
         
         // -- mod="16" dstVar=out
         voice->tmp21_seq = 16.0f;
         out *= voice->tmp21_seq;
         
         // -- mod="sto v_level_2" dstVar=out
         voice->var_v_level_2 = out;
         
         // -- mod="$m_level_3" dstVar=out
         out = voice->mod_level_3_cur;
         
         // -- mod="16" dstVar=out
         voice->tmp22_seq = 16.0f;
         out *= voice->tmp22_seq;
         
         // -- mod="sto v_level_3" dstVar=out
         voice->var_v_level_3 = out;
         
         // -- mod="sin" dstVar=out
         
         // ---- mod="sin" input "freq" seq 1/1
         
         // -- mod="$v_freq_3" dstVar=voice->tmp25_freq
         voice->tmp25_freq = voice->var_v_freq_3;
         voice->tmp24_sin_speed = voice->note_speed_cur * voice->tmp25_freq;
         
         // ---- mod="sin" input "phase" seq 1/1
         
         // -- mod="$v_phrand_3" dstVar=voice->tmp27_phase
         voice->tmp27_phase = voice->var_v_phrand_3;
         
         // -- mod="$v_osc_3" dstVar=voice->tmp27_phase
         voice->tmp28_seq = voice->var_v_osc_3;
         
         // -- mod="$v_fb_3" dstVar=voice->tmp28_seq
         voice->tmp29_seq = voice->var_v_fb_3;
         voice->tmp28_seq *= voice->tmp29_seq;
         voice->tmp27_phase += voice->tmp28_seq;
         voice->tmp26_sin_tmp = ((voice->tmp23_sin_phase + voice->tmp27_phase));
         voice->tmp26_sin_tmp = ffrac_s(voice->tmp26_sin_tmp);
         out = cycle_sine_tbl_f[(unsigned short)(16384 * voice->tmp26_sin_tmp)&16383u];
         voice->tmp23_sin_phase = ffrac_s(voice->tmp23_sin_phase + voice->tmp24_sin_speed);
         
         // -- mod="$v_level_3" dstVar=out
         voice->tmp30_seq = voice->var_v_level_3;
         out *= voice->tmp30_seq;
         
         // -- mod="sto v_osc_3" dstVar=out
         voice->var_v_osc_3 = out;
         
         // -- mod="sin" dstVar=out
         
         // ---- mod="sin" input "freq" seq 1/1
         
         // -- mod="$v_freq_2" dstVar=voice->tmp33_freq
         voice->tmp33_freq = voice->var_v_freq_2;
         voice->tmp32_sin_speed = voice->note_speed_cur * voice->tmp33_freq;
         
         // ---- mod="sin" input "phase" seq 1/1
         
         // -- mod="$v_phrand_2" dstVar=voice->tmp35_phase
         voice->tmp35_phase = voice->var_v_phrand_2;
         
         // -- mod="$v_osc_3" dstVar=voice->tmp35_phase
         voice->tmp36_seq = voice->var_v_osc_3;
         voice->tmp35_phase += voice->tmp36_seq;
         
         // -- mod="$v_osc_2" dstVar=voice->tmp35_phase
         voice->tmp37_seq = voice->var_v_osc_2;
         
         // -- mod="$v_fb_2" dstVar=voice->tmp37_seq
         voice->tmp38_seq = voice->var_v_fb_2;
         voice->tmp37_seq *= voice->tmp38_seq;
         voice->tmp35_phase += voice->tmp37_seq;
         voice->tmp34_sin_tmp = ((voice->tmp31_sin_phase + voice->tmp35_phase));
         voice->tmp34_sin_tmp = ffrac_s(voice->tmp34_sin_tmp);
         out = cycle_sine_tbl_f[(unsigned short)(16384 * voice->tmp34_sin_tmp)&16383u];
         voice->tmp31_sin_phase = ffrac_s(voice->tmp31_sin_phase + voice->tmp32_sin_speed);
         
         // -- mod="$v_level_2" dstVar=out
         voice->tmp39_seq = voice->var_v_level_2;
         out *= voice->tmp39_seq;
         
         // -- mod="sto v_osc_2" dstVar=out
         voice->var_v_osc_2 = out;
         
         // -- mod="sin" dstVar=out
         voice->tmp42_freq = 1;
         voice->tmp41_sin_speed = voice->note_speed_cur * voice->tmp42_freq;
         
         // ---- mod="sin" input "phase" seq 1/1
         
         // -- mod="$v_phrand_1" dstVar=voice->tmp44_phase
         voice->tmp44_phase = voice->var_v_phrand_1;
         
         // -- mod="$v_osc_2" dstVar=voice->tmp44_phase
         voice->tmp44_phase = voice->var_v_osc_2;
         
         // -- mod="$v_osc_1" dstVar=voice->tmp44_phase
         voice->tmp45_seq = voice->var_v_osc_1;
         
         // -- mod="$v_fb_1" dstVar=voice->tmp45_seq
         voice->tmp46_seq = voice->var_v_fb_1;
         voice->tmp45_seq *= voice->tmp46_seq;
         voice->tmp44_phase += voice->tmp45_seq;
         voice->tmp43_sin_tmp = ((voice->tmp40_sin_phase + voice->tmp44_phase));
         voice->tmp43_sin_tmp = ffrac_s(voice->tmp43_sin_tmp);
         out = cycle_sine_tbl_f[(unsigned short)(16384 * voice->tmp43_sin_tmp)&16383u];
         voice->tmp40_sin_phase = ffrac_s(voice->tmp40_sin_phase + voice->tmp41_sin_speed);
         
         // -- mod="sto v_osc_1" dstVar=out
         voice->var_v_osc_1 = out;
   
         /* end calc */

#ifdef OVERSAMPLE_FACTOR
         outOS += out;
#endif // OVERSAMPLE_FACTOR
      }
#ifdef OVERSAMPLE_FACTOR
      // Apply lowpass filter before downsampling
      //   (note) normalized Fc = F/Fs = 0.442947 / sqrt(oversample_factor - 1)
      out = outOS * (1.0f / OVERSAMPLE_FACTOR);
#endif // OVERSAMPLE_FACTOR
      _samplesOut[k]      = out;
      _samplesOut[k + 1u] = out;

      // Next frame
      k += 2u;
      voice->note_speed_cur += voice->note_speed_inc;
      voice->mod_fb_1_cur          += voice->mod_fb_1_inc;
      voice->mod_fb_2_cur          += voice->mod_fb_2_inc;
      voice->mod_fb_3_cur          += voice->mod_fb_3_inc;
      voice->mod_init_cur          += voice->mod_init_inc;
      voice->mod_ratio_2_cur       += voice->mod_ratio_2_inc;
      voice->mod_ratio_3_cur       += voice->mod_ratio_3_inc;
      voice->mod_level_2_cur       += voice->mod_level_2_inc;
      voice->mod_level_3_cur       += voice->mod_level_3_inc;
   } /* loop numFrames */
}

static st_plugin_shared_t *ST_PLUGIN_API loc_shared_new(st_plugin_info_t *_info) {
   osc_fm3s_fb_shared_t *ret = (osc_fm3s_fb_shared_t *)malloc(sizeof(osc_fm3s_fb_shared_t));
   if(NULL != ret)
   {
      memset((void*)ret, 0, sizeof(*ret));
      ret->base.info  = _info;
      memcpy((void*)ret->params, (void*)loc_param_resets, NUM_PARAMS * sizeof(float));
   }
   return &ret->base;
}

static void ST_PLUGIN_API loc_shared_delete(st_plugin_shared_t *_shared) {
   free((void*)_shared);
}

static st_plugin_voice_t *ST_PLUGIN_API loc_voice_new(st_plugin_info_t *_info) {
   osc_fm3s_fb_voice_t *voice = (osc_fm3s_fb_voice_t *)malloc(sizeof(osc_fm3s_fb_voice_t));
   if(NULL != voice)
   {
      memset((void*)voice, 0, sizeof(*voice));
      voice->base.info = _info;
      voice->tmp2_lfsr_state = 17545;
      voice->tmp6_lfsr_state = 56505;
      voice->tmp10_lfsr_state = 61706;
   }
   return &voice->base;
}

static void ST_PLUGIN_API loc_voice_delete(st_plugin_voice_t *_voice) {
   ST_PLUGIN_VOICE_CAST(osc_fm3s_fb_voice_t);

   free((void*)_voice);
}

static void ST_PLUGIN_API loc_plugin_exit(st_plugin_info_t *_info) {
   free((void*)_info);
}

#ifdef USE_CYCLE_SINE_TBL
static void loc_calc_sine_tbl(void) {
#define QCOS_BITS 16
#define QCOS_ONE  (1 << QCOS_BITS)
#define QCOS_MASK (QCOS_ONE - 1)
   // (note) same as in TSR "C" implementation
   float *qcos = cycle_sine_tbl_f + 4096; // quarter cos tbl

   // calc quarter cos tbl
   int k = 0;
   for(int a = 0; a < (QCOS_ONE/4); a += (QCOS_ONE/16384)/*4*/)  // 4096 elements
   {
      int x = a - ((int)(QCOS_ONE * 0.25 + 0.5)) + ((a + ((int)(QCOS_ONE * 0.25 + 0.5)))&~QCOS_MASK);
      x = ((x * ((x<0?-x:x) - ((int)(QCOS_ONE * 0.5 + 0.5)))) >> QCOS_BITS) << 4;
      x += (((((int)(QCOS_ONE * 0.225 + 0.5)) * x) >> QCOS_BITS) * ((x<0?-x:x) - QCOS_ONE)) >> QCOS_BITS;
      qcos[k++] = x / float(QCOS_ONE);
   }

   // 0..90 (rev qtbl)
   int j = 4096;
   k = 0;
   loop(4096)
      cycle_sine_tbl_f[k++] = qcos[--j];

   // 90..180 = cos tbl
   k += 4096;

   // 180..360 (y-flip first half of tbl)
   j = 0;
   loop(8192)
      cycle_sine_tbl_f[k++] = -cycle_sine_tbl_f[j++];

#ifdef USE_CYCLE_SINE_TBL_I
   loop(16384)
      cycle_sine_tbl_i[i] = (short)(cycle_sine_tbl_f[i] * 2048.0f/*FX_ONE*/);
#endif // USE_CYCLE_SINE_TBL_I
}
#endif // USE_CYCLE_SINE_TBL

extern "C" {
st_plugin_info_t *osc_fm3s_fb_init(void) {
   osc_fm3s_fb_info_t *ret = (osc_fm3s_fb_info_t *)malloc(sizeof(osc_fm3s_fb_info_t));

   if(NULL != ret)
   {
      memset(ret, 0, sizeof(*ret));

      ret->base.api_version = ST_PLUGIN_API_VERSION;
      ret->base.id          = "osc_fm3s_fb";  // unique id. don't change this in future builds.
      ret->base.author      = "bsp";
      ret->base.name        = "fm3s osc fb";
      ret->base.short_name  = "fm3s osc fb";
      ret->base.flags       = ST_PLUGIN_FLAG_OSC;
      ret->base.category    = ST_PLUGIN_CAT_UNKNOWN;
      ret->base.num_params  = NUM_PARAMS;
      ret->base.num_mods    = NUM_MODS;

      ret->base.shared_new       = &loc_shared_new;
      ret->base.shared_delete    = &loc_shared_delete;
      ret->base.voice_new        = &loc_voice_new;
      ret->base.voice_delete     = &loc_voice_delete;
      ret->base.get_param_name   = &loc_get_param_name;
      ret->base.get_param_reset  = &loc_get_param_reset;
      ret->base.get_param_value  = &loc_get_param_value;
      ret->base.set_param_value  = &loc_set_param_value;
      ret->base.get_mod_name     = &loc_get_mod_name;
      ret->base.set_sample_rate  = &loc_set_sample_rate;
      ret->base.note_on          = &loc_note_on;
      ret->base.set_mod_value    = &loc_set_mod_value;
      ret->base.prepare_block    = &loc_prepare_block;
      ret->base.process_replace  = &loc_process_replace;
      ret->base.plugin_exit      = &loc_plugin_exit;

#ifdef USE_CYCLE_SINE_TBL
      loc_calc_sine_tbl();
#endif // USE_CYCLE_SINE_TBL
   }

   return &ret->base;
}

#ifndef STFX_SKIP_MAIN_INIT
ST_PLUGIN_APICALL st_plugin_info_t *ST_PLUGIN_API st_plugin_init(unsigned int _pluginIdx) {
   switch(_pluginIdx)
   {
      case 0u:
         return osc_fm3s_fb_init();
   }
   return NULL;
}
#endif // STFX_SKIP_MAIN_INIT

} // extern "C"
